Index: pkpgcounter/trunk/pkpgpdls/tiff.py
===================================================================
--- pkpgcounter/trunk/pkpgpdls/tiff.py (revision 527)
+++ pkpgcounter/trunk/pkpgpdls/tiff.py (revision 555)
@@ -34,4 +34,5 @@
     totiffcommands = [ 'cp "%(infname)s" "%(outfname)s"' ]
     required = [ "cp" ]
+    format = "TIFF"
     def isValid(self) :        
         """Returns True if data is TIFF, else False."""
@@ -39,5 +40,4 @@
         bigendian = (chr(0x4d)*2) + chr(0) + chr(0x2a)
         if self.firstblock[:4] in (littleendian, bigendian) :
-            self.logdebug("DEBUG: Input file is in the TIFF format.")
             return True
         else :    
Index: pkpgcounter/trunk/pkpgpdls/bj.py
===================================================================
--- pkpgcounter/trunk/pkpgpdls/bj.py (revision 553)
+++ pkpgcounter/trunk/pkpgpdls/bj.py (revision 555)
@@ -30,8 +30,8 @@
 class Parser(pdlparser.PDLParser) :
     """A parser for Canon BJ documents."""
+    format = "Canon BJ/BJC"
     def isValid(self) :        
         """Returns True if data is BJ/BJC, else False."""
         if self.firstblock.startswith("\033[K\002\000") :
-            self.logdebug("DEBUG: Input file is in the Canon BJ format.")
             return True
         else :    
Index: pkpgcounter/trunk/pkpgpdls/pdlparser.py
===================================================================
--- pkpgcounter/trunk/pkpgpdls/pdlparser.py (revision 529)
+++ pkpgcounter/trunk/pkpgpdls/pdlparser.py (revision 555)
@@ -43,4 +43,5 @@
     required = []               # Default list of required commands
     openmode = "rb"             # Default file opening mode
+    format = "Unknown"          # Default file format
     def __init__(self, parent, filename, (firstblock, lastblock)) :
         """Initialize the generic parser."""
@@ -54,4 +55,6 @@
         if not self.isValid() :
             raise PDLParserError, "Invalid file format !"
+        else :    
+            self.logdebug("Input file is in the '%s' file format." % self.format)
         try :
             import psyco 
Index: pkpgcounter/trunk/pkpgpdls/ooo.py
===================================================================
--- pkpgcounter/trunk/pkpgpdls/ooo.py (revision 527)
+++ pkpgcounter/trunk/pkpgpdls/ooo.py (revision 555)
@@ -32,4 +32,5 @@
     totiffcommands = [ 'xvfb-run -a abiword --import-extension=.odt --print="| gs -sDEVICE=tiff24nc -dPARANOIDSAFER -dNOPAUSE -dBATCH -dQUIET -r\"%(dpi)i\" -sOutputFile=\"%(outfname)s\" -" "%(infname)s"' ]
     required = [ "xvfb-run", "xauth", "abiword", "gs" ]
+    format = "ISO/IEC DIS 26300"
     def isValid(self) :        
         """Returns True if data is OpenDocument, else False."""
@@ -42,5 +43,4 @@
                 return False
             else :
-                self.logdebug("DEBUG: Input file is in the OpenDocument (ISO/IEC DIS 26300) format.")
                 return True
         else :    
Index: pkpgcounter/trunk/pkpgpdls/lidil.py
===================================================================
--- pkpgcounter/trunk/pkpgpdls/lidil.py (revision 532)
+++ pkpgcounter/trunk/pkpgpdls/lidil.py (revision 555)
@@ -52,4 +52,5 @@
 class Parser(pdlparser.PDLParser) :
     """A parser for HP LIDIL documents."""
+    format = "Hewlett-Packard LIDIL"
     def isValid(self) :    
         """Returns True if data is LIDIL, else False."""
@@ -64,5 +65,4 @@
         if self.firstblock.startswith(BOFMarker) \
            and self.lastblock.endswith(EOFMarker) :
-            self.logdebug("DEBUG: Input file is in the Hewlett-Packard LIDIL format.")
             return True
         else :    
Index: pkpgcounter/trunk/pkpgpdls/escpages03.py
===================================================================
--- pkpgcounter/trunk/pkpgpdls/escpages03.py (revision 522)
+++ pkpgcounter/trunk/pkpgpdls/escpages03.py (revision 555)
@@ -33,9 +33,9 @@
 class Parser(pdlparser.PDLParser) :
     """A parser for ESC/PageS03 documents."""
+    format = "ESC/PageS03"
     def isValid(self) :        
         """Returns True if data is TIFF, else False."""
         if self.firstblock.startswith("\033\1@EJL") and \
             (self.firstblock.find("=ESC/PAGES03\n") != -1) :
-            self.logdebug("DEBUG: Input file is in the ESC/PageS03 format.")
             return True
         else :    
Index: pkpgcounter/trunk/pkpgpdls/zjstream.py
===================================================================
--- pkpgcounter/trunk/pkpgpdls/zjstream.py (revision 532)
+++ pkpgcounter/trunk/pkpgpdls/zjstream.py (revision 555)
@@ -32,8 +32,8 @@
         """Returns True if data is ZjStream, else False."""
         if self.firstblock[:4] == "ZJZJ" :
-            self.logdebug("DEBUG: Input file is in the Zenographics ZjStream (little endian) format.")
+            self.format = "Zenographics ZjStream (little endian)"
             return self.littleEndian()
         elif self.firstblock[:4] == "JZJZ" :    
-            self.logdebug("DEBUG: Input file is in the Zenographics ZjStream (big endian) format.")
+            self.format = "Zenographics ZjStream (big endian)"
             return self.bigEndian()
         else :    
Index: pkpgcounter/trunk/pkpgpdls/qpdl.py
===================================================================
--- pkpgcounter/trunk/pkpgpdls/qpdl.py (revision 522)
+++ pkpgcounter/trunk/pkpgpdls/qpdl.py (revision 555)
@@ -33,4 +33,5 @@
 class Parser(pdlparser.PDLParser) :
     """A parser for QPDL (aka SPL2) documents."""
+    format = "QPDL (aka SPL2)"
     mediasizes = { 
                     # The first values are identical to that of PCLXL
@@ -76,5 +77,4 @@
              ((self.firstblock.find("LANGUAGE=QPDL") != -1) or \
               (self.firstblock.find("LANGUAGE = QPDL") != -1))) :
-            self.logdebug("DEBUG: Input file is in the QPDL (aka SPL2) format.")
             return True
         else :    
Index: pkpgcounter/trunk/pkpgpdls/plain.py
===================================================================
--- pkpgcounter/trunk/pkpgpdls/plain.py (revision 527)
+++ pkpgcounter/trunk/pkpgpdls/plain.py (revision 555)
@@ -33,4 +33,5 @@
     required = [ "a2ps | enscript", "gs" ]
     openmode = "rU"                 
+    format = "plain text"
     def isValid(self) :    
         """Returns True if data is plain text, else False.
@@ -46,5 +47,4 @@
                 lines = lines[0].split("\n")
         if len(lines) > 1 :
-            self.logdebug("DEBUG: Input file seems to be in the plain text format.")
             return True
         else :    
Index: pkpgcounter/trunk/pkpgpdls/pnmascii.py
===================================================================
--- pkpgcounter/trunk/pkpgpdls/pnmascii.py (revision 554)
+++ pkpgcounter/trunk/pkpgpdls/pnmascii.py (revision 555)
@@ -28,8 +28,8 @@
     """A parser for PNM (ascii) documents."""
     openmode = "rU"                 
+    format = "PNM (ascii)"
     def isValid(self) :    
         """Returns True if data is ASCII PNM, else False."""
         if self.firstblock.split()[0] in ("P1", "P2", "P3") :
-            self.logdebug("DEBUG: Input file seems to be in the PNM (ascii) format.")
             self.marker = self.firstblock[:2]
             return True
Index: pkpgcounter/trunk/pkpgpdls/pdf.py
===================================================================
--- pkpgcounter/trunk/pkpgpdls/pdf.py (revision 527)
+++ pkpgcounter/trunk/pkpgpdls/pdf.py (revision 555)
@@ -46,4 +46,5 @@
     required = [ "gs" ]
     openmode = "rU"
+    format = "PDF"
     def isValid(self) :    
         """Returns True if data is PDF, else False."""
@@ -52,5 +53,4 @@
            ((self.firstblock[:128].find("\033%-12345X") != -1) and (self.firstblock.upper().find("LANGUAGE=PDF") != -1)) or \
            (self.firstblock.find("%PDF-") != -1) :
-            self.logdebug("DEBUG: Input file is in the PDF format.")
             return True
         else :    
Index: pkpgcounter/trunk/pkpgpdls/hbp.py
===================================================================
--- pkpgcounter/trunk/pkpgpdls/hbp.py (revision 522)
+++ pkpgcounter/trunk/pkpgpdls/hbp.py (revision 555)
@@ -32,8 +32,8 @@
 class Parser(pdlparser.PDLParser) :
     """A parser for HBP documents."""
+    format = "Brother HBP"
     def isValid(self) :        
         """Returns True if data is HBP, else False."""
         if self.firstblock.find("@PJL ENTER LANGUAGE = HBP\n") != -1 :
-            self.logdebug("DEBUG: Input file is in the HBP format.")
             return True
         else :    
Index: pkpgcounter/trunk/pkpgpdls/pcl345.py
===================================================================
--- pkpgcounter/trunk/pkpgpdls/pcl345.py (revision 543)
+++ pkpgcounter/trunk/pkpgpdls/pcl345.py (revision 555)
@@ -43,4 +43,5 @@
                      ]
     required = [ "pcl6", "gs" ]
+    format = "PCL3/4/5"
     mediasizes = {  # ESC&l####A
                     0 : "Default",
@@ -110,5 +111,4 @@
                (firstblock.find("@PJL ENTER LANGUAGE=PCL\012\015\033") != -1) or \
                (firstblock.startswith(chr(0xcd)+chr(0xca)) and (firstblock.find("\033E\033") != -1)) :
-                self.logdebug("DEBUG: Input file is in the PCL3/4/5 format.")
                 return True
             else :    
Index: pkpgcounter/trunk/pkpgpdls/postscript.py
===================================================================
--- pkpgcounter/trunk/pkpgpdls/postscript.py (revision 527)
+++ pkpgcounter/trunk/pkpgpdls/postscript.py (revision 555)
@@ -34,4 +34,5 @@
     required = [ "gs" ]
     openmode = "rU"
+    format = "PostScript"
     def isValid(self) :    
         """Returns True if data is PostScript, else False."""
@@ -44,5 +45,4 @@
               (self.firstblock.find("LANGUAGE = Postscript") != -1))) or \
               (self.firstblock.find("%!PS-Adobe") != -1) :
-            self.logdebug("DEBUG: Input file is in the PostScript format.")
             return True
         else :    
Index: pkpgcounter/trunk/pkpgpdls/escp2.py
===================================================================
--- pkpgcounter/trunk/pkpgpdls/escp2.py (revision 522)
+++ pkpgcounter/trunk/pkpgpdls/escp2.py (revision 555)
@@ -29,4 +29,5 @@
 class Parser(pdlparser.PDLParser) :
     """A parser for ESC/P2 documents."""
+    format = "ESC/P2"
     def isValid(self) :        
         """Returns True if data is ESC/P2, else False."""
@@ -35,5 +36,4 @@
            self.firstblock.startswith("\n\033@") or \
            self.firstblock.startswith("\0\0\0\033\1@EJL") : # ESC/P Raster ??? Seen on Stylus Photo 1284
-            self.logdebug("DEBUG: Input file is in the ESC/P2 format.")
             return True
         else :    
Index: pkpgcounter/trunk/pkpgpdls/spl1.py
===================================================================
--- pkpgcounter/trunk/pkpgpdls/spl1.py (revision 533)
+++ pkpgcounter/trunk/pkpgpdls/spl1.py (revision 555)
@@ -34,4 +34,5 @@
 class Parser(pdlparser.PDLParser) :
     """A parser for SPL1 documents."""
+    format = "SPL1 (aka GDI)"
     def isValid(self) :    
         """Returns True if data is SPL1, else False."""
@@ -40,5 +41,4 @@
              ((self.firstblock.find("LANGUAGE=SMART") != -1) or \
               (self.firstblock.find("LANGUAGE = SMART") != -1))) :
-            self.logdebug("DEBUG: Input file is in the SPL1 format.")
             return True
         else :    
Index: pkpgcounter/trunk/pkpgpdls/cfax.py
===================================================================
--- pkpgcounter/trunk/pkpgpdls/cfax.py (revision 539)
+++ pkpgcounter/trunk/pkpgpdls/cfax.py (revision 555)
@@ -29,8 +29,8 @@
 class Parser(pdlparser.PDLParser) :
     """A parser for Structured Fax documents."""
+    format = "Structured Fax"
     def isValid(self) :        
         """Returns True if data is Structured Fax, else False."""
         if self.firstblock.startswith("Sfff") :
-            self.logdebug("DEBUG: Input file is in the Structured Fax format.")
             return True
         else :    
Index: pkpgcounter/trunk/pkpgpdls/pclxl.py
===================================================================
--- pkpgcounter/trunk/pkpgpdls/pclxl.py (revision 527)
+++ pkpgcounter/trunk/pkpgpdls/pclxl.py (revision 555)
@@ -37,4 +37,5 @@
                      ]
     required = [ "pcl6", "gs" ]
+    format = "PCLXL (aka PCL6)"
     mediasizes = { 
                     0 : "Letter",
@@ -89,5 +90,4 @@
               (self.firstblock.find("LANGUAGE = PCLXL") != -1)))) \
              or ((self.firstblock.startswith(chr(0xcd)+chr(0xca)) and (self.firstblock.find(" HP-PCL XL;") != -1))) :
-            self.logdebug("DEBUG: Input file is in the PCLXL (aka PCL6) format.")
             return True
         else :    
Index: pkpgcounter/trunk/pkpgpdls/dvi.py
===================================================================
--- pkpgcounter/trunk/pkpgpdls/dvi.py (revision 527)
+++ pkpgcounter/trunk/pkpgpdls/dvi.py (revision 555)
@@ -34,4 +34,5 @@
     totiffcommands = [ 'dvips -q -o - "%(infname)s" | gs -sDEVICE=tiff24nc -dPARANOIDSAFER -dNOPAUSE -dBATCH -dQUIET -r"%(dpi)i" -sOutputFile="%(outfname)s" -' ]
     required = [ "dvips", "gs" ]
+    format = "DVI"
     def isValid(self) :        
         """Returns True if data is DVI, else False."""
@@ -39,5 +40,4 @@
             if (ord(self.firstblock[0]) == 0xf7) \
                 and (ord(self.lastblock[-1]) == 0xdf) :
-                self.logdebug("DEBUG: Input file is in the DVI format.")
                 return True
             else :    
Index: pkpgcounter/trunk/pkpgpdls/pil.py
===================================================================
--- pkpgcounter/trunk/pkpgpdls/pil.py (revision 527)
+++ pkpgcounter/trunk/pkpgpdls/pil.py (revision 555)
@@ -44,5 +44,5 @@
             return False
         else :    
-            self.logdebug("DEBUG: Input file seems to be an image in the %s (%s) format." % (image.format, image.format_description))
+            self.format = "%s (%s)" % (image.format, image.format_description)
             return True
             
Index: pkpgcounter/trunk/pkpgpdls/mscrap.py
===================================================================
--- pkpgcounter/trunk/pkpgpdls/mscrap.py (revision 529)
+++ pkpgcounter/trunk/pkpgpdls/mscrap.py (revision 555)
@@ -33,4 +33,5 @@
     totiffcommands = [ 'xvfb-run -a abiword --import-extension=.doc --print="| gs -sDEVICE=tiff24nc -dPARANOIDSAFER -dNOPAUSE -dBATCH -dQUIET -r\"%(dpi)i\" -sOutputFile=\"%(outfname)s\" -" "%(infname)s"' ]
     required = [ "xvfb-run", "xauth", "abiword", "gs" ]
+    format = "Microsoft shitty"
     def isValid(self) :    
         """Returns True if data is MS crap, else False.
@@ -46,5 +47,4 @@
            or self.firstblock.startswith("\x31\xbe\x00\x00") \
            or self.firstblock[2112:].startswith("MSWordDoc") :
-            self.logdebug("DEBUG: Input file seems to be in a Microsoft shitty file format.")
             # Here we do the missing test because all commands will be needed even in page counting mode
             if self.isMissing(self.required) :