Index: pkpgcounter/trunk/BUGS
===================================================================
--- pkpgcounter/trunk/BUGS (revision 463)
+++ pkpgcounter/trunk/BUGS (revision 564)
@@ -3,5 +3,5 @@
 pkpgcounter : a generic Page Description Language parser
 
-(c) 2003, 2004, 2005, 2006, 2007 Jerome Alet <alet@librelogiciel.com>
+(c) 2003, 2004, 2005, 2006, 2007, 2008 Jerome Alet <alet@librelogiciel.com>
 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
Index: pkpgcounter/trunk/tests/gstests.py
===================================================================
--- pkpgcounter/trunk/tests/gstests.py (revision 559)
+++ pkpgcounter/trunk/tests/gstests.py (revision 564)
@@ -1,8 +1,8 @@
 #! /usr/bin/env python
-# -*- coding: ISO-8859-15 -*-
+# -*- coding: UTF-8 -*-
 #
 # pkpgcounter : a generic Page Description Language parser
 #
-# (c) 2003, 2004, 2005, 2006, 2007 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005, 2006, 2007, 2008 Jerome Alet <alet@librelogiciel.com>
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
Index: pkpgcounter/trunk/tests/runcolors.py
===================================================================
--- pkpgcounter/trunk/tests/runcolors.py (revision 463)
+++ pkpgcounter/trunk/tests/runcolors.py (revision 564)
@@ -1,8 +1,8 @@
 #! /usr/bin/env python
-# -*- coding: ISO-8859-15 -*-
+# -*- coding: UTF-8 -*-
 #
 # pkpgcounter : a generic Page Description Language parser
 #
-# (c) 2003, 2004, 2005, 2006, 2007 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005, 2006, 2007, 2008 Jerome Alet <alet@librelogiciel.com>
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
Index: pkpgcounter/trunk/tests/runtest.sh
===================================================================
--- pkpgcounter/trunk/tests/runtest.sh (revision 510)
+++ pkpgcounter/trunk/tests/runtest.sh (revision 564)
@@ -3,5 +3,5 @@
 # pkpgcounter : a generic Page Description Language parser
 #
-# (c) 2003, 2004, 2005, 2006, 2007 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005, 2006, 2007, 2008 Jerome Alet <alet@librelogiciel.com>
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
Index: pkpgcounter/trunk/pkpgpdls/tiff.py
===================================================================
--- pkpgcounter/trunk/pkpgpdls/tiff.py (revision 555)
+++ pkpgcounter/trunk/pkpgpdls/tiff.py (revision 564)
@@ -1,8 +1,7 @@
-#! /usr/bin/env python
-# -*- coding: ISO-8859-15 -*-
+# -*- coding: UTF-8 -*-
 #
 # pkpgcounter : a generic Page Description Language parser
 #
-# (c) 2003, 2004, 2005, 2006, 2007 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005, 2006, 2007, 2008 Jerome Alet <alet@librelogiciel.com>
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
Index: pkpgcounter/trunk/pkpgpdls/bj.py
===================================================================
--- pkpgcounter/trunk/pkpgpdls/bj.py (revision 555)
+++ pkpgcounter/trunk/pkpgpdls/bj.py (revision 564)
@@ -1,8 +1,7 @@
-#! /usr/bin/env python
-# -*- coding: ISO-8859-15 -*-
+# -*- coding: UTF-8 -*-
 #
 # pkpgcounter : a generic Page Description Language parser
 #
-# (c) 2003, 2004, 2005, 2006, 2007 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005, 2006, 2007, 2008 Jerome Alet <alet@librelogiciel.com>
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
Index: pkpgcounter/trunk/pkpgpdls/pdlparser.py
===================================================================
--- pkpgcounter/trunk/pkpgpdls/pdlparser.py (revision 555)
+++ pkpgcounter/trunk/pkpgpdls/pdlparser.py (revision 564)
@@ -1,6 +1,7 @@
+# -*- coding: UTF-8 -*-
 #
 # pkpgcounter : a generic Page Description Language parser
 #
-# (c) 2003, 2004, 2005, 2006, 2007 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005, 2006, 2007, 2008 Jerome Alet <alet@librelogiciel.com>
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
Index: pkpgcounter/trunk/pkpgpdls/ooo.py
===================================================================
--- pkpgcounter/trunk/pkpgpdls/ooo.py (revision 555)
+++ pkpgcounter/trunk/pkpgpdls/ooo.py (revision 564)
@@ -1,8 +1,7 @@
-#! /usr/bin/env python
-# -*- coding: ISO-8859-15 -*-
+# -*- coding: UTF-8 -*-
 #
 # pkpgcounter : a generic Page Description Language parser
 #
-# (c) 2003, 2004, 2005, 2006, 2007 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005, 2006, 2007, 2008 Jerome Alet <alet@librelogiciel.com>
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
Index: pkpgcounter/trunk/pkpgpdls/lidil.py
===================================================================
--- pkpgcounter/trunk/pkpgpdls/lidil.py (revision 555)
+++ pkpgcounter/trunk/pkpgpdls/lidil.py (revision 564)
@@ -1,8 +1,7 @@
-#! /usr/bin/env python
-# -*- coding: ISO-8859-15 -*-
+# -*- coding: UTF-8 -*-
 #
 # pkpgcounter : a generic Page Description Language parser
 #
-# (c) 2003, 2004, 2005, 2006, 2007 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005, 2006, 2007, 2008 Jerome Alet <alet@librelogiciel.com>
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
Index: pkpgcounter/trunk/pkpgpdls/inkcoverage.py
===================================================================
--- pkpgcounter/trunk/pkpgpdls/inkcoverage.py (revision 527)
+++ pkpgcounter/trunk/pkpgpdls/inkcoverage.py (revision 564)
@@ -1,8 +1,7 @@
-#! /usr/bin/env python
-# -*- coding: ISO-8859-15 -*-
+# -*- coding: UTF-8 -*-
 #
 # pkpgcounter : a generic Page Description Language parser
 #
-# (c) 2003, 2004, 2005, 2006, 2007 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005, 2006, 2007, 2008 Jerome Alet <alet@librelogiciel.com>
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
Index: pkpgcounter/trunk/pkpgpdls/escpages03.py
===================================================================
--- pkpgcounter/trunk/pkpgpdls/escpages03.py (revision 555)
+++ pkpgcounter/trunk/pkpgpdls/escpages03.py (revision 564)
@@ -1,8 +1,7 @@
-#! /usr/bin/env python
-# -*- coding: ISO-8859-15 -*-
+# -*- coding: UTF-8 -*-
 #
 # pkpgcounter : a generic Page Description Language parser
 #
-# (c) 2003, 2004, 2005, 2006, 2007 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005, 2006, 2007, 2008 Jerome Alet <alet@librelogiciel.com>
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
Index: pkpgcounter/trunk/pkpgpdls/__init__.py
===================================================================
--- pkpgcounter/trunk/pkpgpdls/__init__.py (revision 463)
+++ pkpgcounter/trunk/pkpgpdls/__init__.py (revision 564)
@@ -1,6 +1,7 @@
+# -*- coding: UTF-8 -*-
 #
 # pkpgcounter : a generic Page Description Language parser
 #
-# (c) 2003, 2004, 2005, 2006, 2007 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005, 2006, 2007, 2008 Jerome Alet <alet@librelogiciel.com>
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
Index: pkpgcounter/trunk/pkpgpdls/zjstream.py
===================================================================
--- pkpgcounter/trunk/pkpgpdls/zjstream.py (revision 555)
+++ pkpgcounter/trunk/pkpgpdls/zjstream.py (revision 564)
@@ -1,8 +1,7 @@
-#! /usr/bin/env python
-# -*- coding: ISO-8859-15 -*-
+# -*- coding: UTF-8 -*-
 #
 # pkpgcounter : a generic Page Description Language parser
 #
-# (c) 2003, 2004, 2005, 2006, 2007 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005, 2006, 2007, 2008 Jerome Alet <alet@librelogiciel.com>
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
Index: pkpgcounter/trunk/pkpgpdls/qpdl.py
===================================================================
--- pkpgcounter/trunk/pkpgpdls/qpdl.py (revision 555)
+++ pkpgcounter/trunk/pkpgpdls/qpdl.py (revision 564)
@@ -1,8 +1,7 @@
-#! /usr/bin/env python
-# -*- coding: ISO-8859-15 -*-
+# -*- coding: UTF-8 -*-
 #
 # pkpgcounter : a generic Page Description Language parser
 #
-# (c) 2003, 2004, 2005, 2006, 2007 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005, 2006, 2007, 2008 Jerome Alet <alet@librelogiciel.com>
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
Index: pkpgcounter/trunk/pkpgpdls/plain.py
===================================================================
--- pkpgcounter/trunk/pkpgpdls/plain.py (revision 555)
+++ pkpgcounter/trunk/pkpgpdls/plain.py (revision 564)
@@ -1,8 +1,7 @@
-#! /usr/bin/env python
-# -*- coding: ISO-8859-15 -*-
+# -*- coding: UTF-8 -*-
 #
 # pkpgcounter : a generic Page Description Language parser
 #
-# (c) 2003, 2004, 2005, 2006, 2007 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005, 2006, 2007, 2008 Jerome Alet <alet@librelogiciel.com>
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
Index: pkpgcounter/trunk/pkpgpdls/pnmascii.py
===================================================================
--- pkpgcounter/trunk/pkpgpdls/pnmascii.py (revision 555)
+++ pkpgcounter/trunk/pkpgpdls/pnmascii.py (revision 564)
@@ -1,8 +1,7 @@
-#! /usr/bin/env python
-# -*- coding: ISO-8859-15 -*-
+# -*- coding: UTF-8 -*-
 #
 # pkpgcounter : a generic Page Description Language parser
 #
-# (c) 2003, 2004, 2005, 2006, 2007 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005, 2006, 2007, 2008 Jerome Alet <alet@librelogiciel.com>
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
Index: pkpgcounter/trunk/pkpgpdls/pdf.py
===================================================================
--- pkpgcounter/trunk/pkpgpdls/pdf.py (revision 555)
+++ pkpgcounter/trunk/pkpgpdls/pdf.py (revision 564)
@@ -1,8 +1,7 @@
-#! /usr/bin/env python
-# -*- coding: ISO-8859-15 -*-
+# -*- coding: UTF-8 -*-
 #
 # pkpgcounter : a generic Page Description Language parser
 #
-# (c) 2003, 2004, 2005, 2006, 2007 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005, 2006, 2007, 2008 Jerome Alet <alet@librelogiciel.com>
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
Index: pkpgcounter/trunk/pkpgpdls/hbp.py
===================================================================
--- pkpgcounter/trunk/pkpgpdls/hbp.py (revision 555)
+++ pkpgcounter/trunk/pkpgpdls/hbp.py (revision 564)
@@ -1,8 +1,7 @@
-#! /usr/bin/env python
-# -*- coding: ISO-8859-15 -*-
+# -*- coding: UTF-8 -*-
 #
 # pkpgcounter : a generic Page Description Language parser
 #
-# (c) 2003, 2004, 2005, 2006, 2007 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005, 2006, 2007, 2008 Jerome Alet <alet@librelogiciel.com>
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
Index: pkpgcounter/trunk/pkpgpdls/pcl345.py
===================================================================
--- pkpgcounter/trunk/pkpgpdls/pcl345.py (revision 555)
+++ pkpgcounter/trunk/pkpgpdls/pcl345.py (revision 564)
@@ -1,8 +1,7 @@
-#! /usr/bin/env python
-# -*- coding: ISO-8859-15 -*-
+# -*- coding: UTF-8 -*-
 #
 # pkpgcounter : a generic Page Description Language parser
 #
-# (c) 2003, 2004, 2005, 2006, 2007 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005, 2006, 2007, 2008 Jerome Alet <alet@librelogiciel.com>
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
Index: pkpgcounter/trunk/pkpgpdls/postscript.py
===================================================================
--- pkpgcounter/trunk/pkpgpdls/postscript.py (revision 562)
+++ pkpgcounter/trunk/pkpgpdls/postscript.py (revision 564)
@@ -1,8 +1,7 @@
-#! /usr/bin/env python
-# -*- coding: ISO-8859-15 -*-
+# -*- coding: UTF-8 -*-
 #
 # pkpgcounter : a generic Page Description Language parser
 #
-# (c) 2003, 2004, 2005, 2006, 2007 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005, 2006, 2007, 2008 Jerome Alet <alet@librelogiciel.com>
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
Index: pkpgcounter/trunk/pkpgpdls/escp2.py
===================================================================
--- pkpgcounter/trunk/pkpgpdls/escp2.py (revision 555)
+++ pkpgcounter/trunk/pkpgpdls/escp2.py (revision 564)
@@ -1,8 +1,7 @@
-#! /usr/bin/env python
-# -*- coding: ISO-8859-15 -*-
+# -*- coding: UTF-8 -*-
 #
 # pkpgcounter : a generic Page Description Language parser
 #
-# (c) 2003, 2004, 2005, 2006, 2007 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005, 2006, 2007, 2008 Jerome Alet <alet@librelogiciel.com>
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
Index: pkpgcounter/trunk/pkpgpdls/spl1.py
===================================================================
--- pkpgcounter/trunk/pkpgpdls/spl1.py (revision 555)
+++ pkpgcounter/trunk/pkpgpdls/spl1.py (revision 564)
@@ -1,8 +1,7 @@
-#! /usr/bin/env python
-# -*- coding: ISO-8859-15 -*-
+# -*- coding: UTF-8 -*-
 #
 # pkpgcounter : a generic Page Description Language parser
 #
-# (c) 2003, 2004, 2005, 2006, 2007 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005, 2006, 2007, 2008 Jerome Alet <alet@librelogiciel.com>
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
Index: pkpgcounter/trunk/pkpgpdls/cfax.py
===================================================================
--- pkpgcounter/trunk/pkpgpdls/cfax.py (revision 555)
+++ pkpgcounter/trunk/pkpgpdls/cfax.py (revision 564)
@@ -1,8 +1,7 @@
-#! /usr/bin/env python
-# -*- coding: ISO-8859-15 -*-
+# -*- coding: UTF-8 -*-
 #
 # pkpgcounter : a generic Page Description Language parser
 #
-# (c) 2003, 2004, 2005, 2006, 2007 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005, 2006, 2007, 2008 Jerome Alet <alet@librelogiciel.com>
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
Index: pkpgcounter/trunk/pkpgpdls/pclxl.py
===================================================================
--- pkpgcounter/trunk/pkpgpdls/pclxl.py (revision 555)
+++ pkpgcounter/trunk/pkpgpdls/pclxl.py (revision 564)
@@ -1,8 +1,7 @@
-#! /usr/bin/env python
-# -*- coding: ISO-8859-15 -*-
+# -*- coding: UTF-8 -*-
 #
 # pkpgcounter : a generic Page Description Language parser
 #
-# (c) 2003, 2004, 2005, 2006, 2007 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005, 2006, 2007, 2008 Jerome Alet <alet@librelogiciel.com>
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
Index: pkpgcounter/trunk/pkpgpdls/dvi.py
===================================================================
--- pkpgcounter/trunk/pkpgpdls/dvi.py (revision 555)
+++ pkpgcounter/trunk/pkpgpdls/dvi.py (revision 564)
@@ -1,8 +1,7 @@
-#! /usr/bin/env python
-# -*- coding: ISO-8859-15 -*-
+# -*- coding: UTF-8 -*-
 #
 # pkpgcounter : a generic Page Description Language parser
 #
-# (c) 2003, 2004, 2005, 2006, 2007 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005, 2006, 2007, 2008 Jerome Alet <alet@librelogiciel.com>
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
Index: pkpgcounter/trunk/pkpgpdls/pil.py
===================================================================
--- pkpgcounter/trunk/pkpgpdls/pil.py (revision 555)
+++ pkpgcounter/trunk/pkpgpdls/pil.py (revision 564)
@@ -1,8 +1,7 @@
-#! /usr/bin/env python
-# -*- coding: ISO-8859-15 -*-
+# -*- coding: UTF-8 -*-
 #
 # pkpgcounter : a generic Page Description Language parser
 #
-# (c) 2003, 2004, 2005, 2006, 2007 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005, 2006, 2007, 2008 Jerome Alet <alet@librelogiciel.com>
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
Index: pkpgcounter/trunk/pkpgpdls/mscrap.py
===================================================================
--- pkpgcounter/trunk/pkpgpdls/mscrap.py (revision 555)
+++ pkpgcounter/trunk/pkpgpdls/mscrap.py (revision 564)
@@ -1,8 +1,7 @@
-#! /usr/bin/env python
-# -*- coding: ISO-8859-15 -*-
+# -*- coding: UTF-8 -*-
 #
 # pkpgcounter : a generic Page Description Language parser
 #
-# (c) 2003, 2004, 2005, 2006, 2007 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005, 2006, 2007, 2008 Jerome Alet <alet@librelogiciel.com>
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
Index: pkpgcounter/trunk/pkpgpdls/analyzer.py
===================================================================
--- pkpgcounter/trunk/pkpgpdls/analyzer.py (revision 547)
+++ pkpgcounter/trunk/pkpgpdls/analyzer.py (revision 564)
@@ -1,6 +1,7 @@
+# -*- coding: UTF-8 -*-
 #
 # pkpgcounter : a generic Page Description Language parser
 #
-# (c) 2003, 2004, 2005, 2006, 2007 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005, 2006, 2007, 2008 Jerome Alet <alet@librelogiciel.com>
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
Index: pkpgcounter/trunk/pkpgpdls/pjl.py
===================================================================
--- pkpgcounter/trunk/pkpgpdls/pjl.py (revision 563)
+++ pkpgcounter/trunk/pkpgpdls/pjl.py (revision 564)
@@ -1,8 +1,7 @@
-#! /usr/bin/env python
-# -*- coding: ISO-8859-15 -*-
+# -*- coding: UTF-8 -*-
 #
 # pkpgcounter : a generic Page Description Language parser
 #
-# (c) 2003, 2004, 2005, 2006, 2007 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005, 2006, 2007, 2008 Jerome Alet <alet@librelogiciel.com>
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
Index: pkpgcounter/trunk/pkpgpdls/version.py
===================================================================
--- pkpgcounter/trunk/pkpgpdls/version.py (revision 560)
+++ pkpgcounter/trunk/pkpgpdls/version.py (revision 564)
@@ -1,6 +1,7 @@
+# -*- coding: UTF-8 -*-
 #
 # pkpgcounter : a generic Page Description Language parser
 #
-# (c) 2003, 2004, 2005, 2006, 2007 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005, 2006, 2007, 2008 Jerome Alet <alet@librelogiciel.com>
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -28,5 +29,5 @@
 __author__ = "Jerome Alet"
 __authoremail__ = "alet@librelogiciel.com"
-__years__ = "2003, 2004, 2005, 2006, 2007"
+__years__ = "2003, 2004, 2005, 2006, 2007, 2008"
 
 __gplblurb__ = """This program is free software: you can redistribute it and/or modify
Index: pkpgcounter/trunk/setup.py
===================================================================
--- pkpgcounter/trunk/setup.py (revision 463)
+++ pkpgcounter/trunk/setup.py (revision 564)
@@ -1,8 +1,8 @@
 #! /usr/bin/env python
-# -*- coding: ISO-8859-15 -*-
+# -*- coding: UTF-8 -*-
 #
 # pkpgcounter : a generic Page Description Language parser
 #
-# (c) 2003, 2004, 2005, 2006, 2007 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005, 2006, 2007, 2008 Jerome Alet <alet@librelogiciel.com>
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
Index: pkpgcounter/trunk/bin/pkpgcounter
===================================================================
--- pkpgcounter/trunk/bin/pkpgcounter (revision 549)
+++ pkpgcounter/trunk/bin/pkpgcounter (revision 564)
@@ -1,8 +1,8 @@
 #! /usr/bin/env python
-# -*- coding: ISO-8859-15 -*-
+# -*- coding: UTF-8 -*-
 #
 # pkpgcounter : a generic Page Description Language parser
 #
-# (c) 2003, 2004, 2005, 2006, 2007 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005, 2006, 2007, 2008 Jerome Alet <alet@librelogiciel.com>
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
Index: pkpgcounter/trunk/clean.sh
===================================================================
--- pkpgcounter/trunk/clean.sh (revision 516)
+++ pkpgcounter/trunk/clean.sh (revision 564)
@@ -3,5 +3,5 @@
 # pkpgcounter : a generic Page Description Language parser
 #
-# (c) 2003, 2004, 2005, 2006, 2007 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005, 2006, 2007, 2008 Jerome Alet <alet@librelogiciel.com>
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
Index: pkpgcounter/trunk/man/pkpgcounter.1
===================================================================
--- pkpgcounter/trunk/man/pkpgcounter.1 (revision 557)
+++ pkpgcounter/trunk/man/pkpgcounter.1 (revision 564)
@@ -1,8 +1,8 @@
 .\" DO NOT MODIFY THIS FILE!  It was generated by help2man 1.36.
-.TH PKPGCOUNTER "1" "December 2007" "C@LL - Conseil Internet & Logiciels Libres" "User Commands"
+.TH PKPGCOUNTER "1" "January 2008" "C@LL - Conseil Internet & Logiciels Libres" "User Commands"
 .SH NAME
 pkpgcounter \- count number of pages required to print various types of documents
 .SH DESCRIPTION
-pkpgcounter v3.50 (c) 2003, 2004, 2005, 2006, 2007 Jerome Alet
+pkpgcounter v3.51alpha (c) 2003, 2004, 2005, 2006, 2007, 2008 Jerome Alet
 .PP
 pkpgcounter is a generic Page Description Language parser.
Index: pkpgcounter/trunk/man/genman.sh
===================================================================
--- pkpgcounter/trunk/man/genman.sh (revision 531)
+++ pkpgcounter/trunk/man/genman.sh (revision 564)
@@ -3,5 +3,5 @@
 # pkpgcounter : a generic Page Description Language parser.
 #
-# (c) 2003, 2004, 2005, 2006, 2007 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005, 2006, 2007, 2008 Jerome Alet <alet@librelogiciel.com>
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -23,9 +23,9 @@
     help2man --no-info \
              --section=1 \
-	     --name="count number of pages required to print various types of documents" \
-	     --manual="User Commands" \
-	     --source="C@LL - Conseil Internet & Logiciels Libres" \
-	     --output="temp$prog.1" \
-	     $prog ; 
+             --name="count number of pages required to print various types of documents" \
+             --manual="User Commands" \
+             --source="C@LL - Conseil Internet & Logiciels Libres" \
+             --output="temp$prog.1" \
+             $prog ; 
     /bin/sed -e "s/--/\\\-\\\-/g" <"temp$prog.1" >"$prog.1" ;
     /bin/rm -f "temp$prog.1"
Index: pkpgcounter/trunk/NEWS
===================================================================
--- pkpgcounter/trunk/NEWS (revision 561)
+++ pkpgcounter/trunk/NEWS (revision 564)
@@ -3,5 +3,5 @@
 pkpgcounter : a generic Page Description Language parser
 
-(c) 2003, 2004, 2005, 2006, 2007 Jerome Alet <alet@librelogiciel.com>
+(c) 2003, 2004, 2005, 2006, 2007, 2008 Jerome Alet <alet@librelogiciel.com>
 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
Index: pkpgcounter/trunk/CREDITS
===================================================================
--- pkpgcounter/trunk/CREDITS (revision 512)
+++ pkpgcounter/trunk/CREDITS (revision 564)
@@ -3,5 +3,5 @@
 pkpgcounter : a generic Page Description Language parser
 
-(c) 2003, 2004, 2005, 2006, 2007 Jerome Alet <alet@librelogiciel.com>
+(c) 2003, 2004, 2005, 2006, 2007, 2008 Jerome Alet <alet@librelogiciel.com>
 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
Index: pkpgcounter/trunk/README
===================================================================
--- pkpgcounter/trunk/README (revision 556)
+++ pkpgcounter/trunk/README (revision 564)
@@ -3,5 +3,5 @@
 pkpgcounter : a generic Page Description Language parser
 
-(c) 2003, 2004, 2005, 2006, 2007 Jerome Alet <alet@librelogiciel.com>
+(c) 2003, 2004, 2005, 2006, 2007, 2008 Jerome Alet <alet@librelogiciel.com>
 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by