Index: /tea4cups/trunk/tea4cups
===================================================================
--- /tea4cups/trunk/tea4cups (revision 575)
+++ /tea4cups/trunk/tea4cups (revision 576)
@@ -2,5 +2,5 @@
 # -*- coding: ISO-8859-15 -*-
 
-# CupsOfTee : Tee for CUPS
+# Tea4CUPS : Tee for CUPS
 #
 # (c) 2005 Jerome Alet <alet@librelogiciel.com>
@@ -32,5 +32,5 @@
 
 class TeeError(Exception):
-    """Base exception for CupsOfTee related stuff."""
+    """Base exception for Tea4CUPS related stuff."""
     def __init__(self, message = ""):
         self.message = message
@@ -55,5 +55,5 @@
         """Initializes the CUPS backend wrapper."""
         confdir = os.environ.get("CUPS_SERVERROOT", ".") 
-        self.conffile = os.path.join(confdir, "cupsoftee.conf")
+        self.conffile = os.path.join(confdir, "tea4cups.conf")
         if os.path.isfile(self.conffile) :
             self.config = ConfigParser.ConfigParser()
@@ -194,5 +194,5 @@
                             if fullname.startswith('"') and fullname.endswith('"') :
                                 fullname = fullname[1:-1]
-                            available.append('%s cupsoftee:%s "CupsOfTee+%s" "CupsOfTee managed %s"' \
+                            available.append('%s tea4cups:%s "Tea4CUPS+%s" "Tea4CUPS managed %s"' \
                                                  % (devicetype, device, name, fullname))
             os.remove(lockfilename)
@@ -209,5 +209,5 @@
                 
             # check that the DEVICE_URI environment variable's value is 
-            # prefixed with "cupsoftee:" otherwise don't touch it.
+            # prefixed with "tea4cups:" otherwise don't touch it.
             # If this is the case, we have to remove the prefix from 
             # the environment before launching the real backend in cupspykota
Index: /tea4cups/trunk/tea4cups.conf
===================================================================
--- /tea4cups/trunk/tea4cups.conf (revision 575)
+++ /tea4cups/trunk/tea4cups.conf (revision 576)
@@ -1,5 +1,5 @@
 # $Id$
 #
-# CupsOfTee : Tee for CUPS
+# Tea4CUPS : Tee for CUPS
 #
 # This program is free software; you can redistribute it and/or modify
Index: /tea4cups/trunk/README
===================================================================
--- /tea4cups/trunk/README (revision 572)
+++ /tea4cups/trunk/README (revision 576)
@@ -1,5 +1,5 @@
 # $Id$
 
-CupsOfTee : Tee for CUPS
+Tea4CUPS : Tee for CUPS
 
 This program is free software; you can redistribute it and/or modify
@@ -19,8 +19,8 @@
 =============================================================================
 
-CupsOfTee is the equivalent of the *nix command 'tee', but as a CUPS
+Tea4CUPS is the equivalent of the *nix command 'tee', but as a CUPS
 backend.
 
-CupsOfTee behaves just like any other CUPS backend, but allows you to
+Tea4CUPS behaves just like any other CUPS backend, but allows you to
 transparently send print jobs' datas to any number of outputs : other
 CUPS backends, files or pipes.
@@ -38,23 +38,23 @@
 --------------
 
-  1 - Copy the 'cupsoftee' command into CUPS' backend directory, 
+  1 - Copy the 'tea4cups' command into CUPS' backend directory, 
       for example :
       
-        $ cp cupsoftee /usr/lib/cups/backend
+        $ cp tea4cups /usr/lib/cups/backend
         
   2 - Restart CUPS in order for this new backend to be detected.        
   
   3 - Either from CUPS' web interface, add new printers with 
-      'CupsOfTee managed' in front of the device's name.
+      'Tea4CUPS managed' in front of the device's name.
           
       Or by directly modifying CUPS' printers.conf file, prepend    
-      each DeviceURI value with 'cupsoftee://', and restart CUPS.
+      each DeviceURI value with 'tea4cups://', and restart CUPS.
       
-  4 - Copy cupsoftee.conf into CUPS' configuration directory (where    
+  4 - Copy tea4cups.conf into CUPS' configuration directory (where    
       cupsd.conf resides) :
       
-        $ cp cupsoftee.conf /etc/cups/
+        $ cp tea4cups.conf /etc/cups/
         
-  5 - Modify cupsoftee.conf to suit your needs. Several examples      
+  5 - Modify tea4cups.conf to suit your needs. Several examples      
       are included.
       
@@ -70,8 +70,8 @@
   2 - Restart CUPS.
   
-  3 - Set "debug: yes" in the [global] section of cupsoftee.conf
+  3 - Set "debug: yes" in the [global] section of tea4cups.conf
   
   4 - Print something on a print queue managed
-      by CupsOfTee.
+      by Tea4CUPS.
       
   5 - Look at CUPS' error_log file for diagnostic and error messages.